/* GCC */
#include <iostream>
#include<vector>
#include<cstdio>
#include<list>
#include<sstream>
#include<string>
using namespace std;
int n,m,t,start,finish;
list<pair<int,int> > pos[600];
struct po
{
    int to,cost,time_d,time_a;
    po(int _to,int _cost,int _time_d,int _time_a):to(_to),cost(_cost),time_d(_time_d),time_a(_time_a){};
};
void update(int v,pair<int,int> p)
{
    for(list<pair<int,int> >::iterator i=pos[v].begin();i!=pos[v].end();i++)
    {
        if(p.first>=i->first && p.second>=i->second)
            return;
    }
    for(list<pair<int,int> >::iterator i=pos[v].begin();i!=pos[v].end();)
    {
        if(p.first<=i->first && p.second<=i->second)
            i=pos[v].erase(i);
        else
            i++;
    }
    pos[v].push_back(p);
}
vector<po> gr[600];
int main()
{
    freopen("tax.in","r",stdin);
    freopen("tax.out","w",stdout);
    cin>>n>>m>>t>>start>>finish;
    string line;
    while(getline(cin,line))
    {
        stringstream in(line);
        int to,cost,time_d,time_a;
        int pre=-1;
        while(in>>to>>time_a>>cost)
        {
            if(pre!=-1)
                gr[pre].push_back(po(to,cost,time_d,time_a));
            pre=to;
            time_d=time_a;
        }
    }
    pos[start].push_back(make_pair(t,0));
    for(int co=0;co<n;co++)
    {
        for(int i=1; i<=n; i++)
        {
            for(list<pair<int,int> >::iterator it=pos[i].begin();it!=pos[i].end();it++)
            {
                for(int j=0;j<gr[i].size();j++)
                {
                    int cost=it->second+gr[i][j].cost;
                    int tim=it->first;
                    if(tim%1440>gr[i][j].time_d)
                    {
                        tim=((tim/1440)+1)*1440;
                    }
                    tim=(tim/1440)*1440+gr[i][j].time_a;
                    update(gr[i][j].to,make_pair(tim,cost));
                }
            }
        }
    }
    if(pos[finish].front().first>pos[finish].back().first)
    {
        cout<<pos[finish].back().first<<' '<<pos[finish].back().second<<endl;
        cout<<pos[finish].front().first<<' '<<pos[finish].front().second<<endl;
    }
    else
    {
        cout<<pos[finish].front().first<<' '<<pos[finish].front().second<<endl;
        cout<<pos[finish].back().first<<' '<<pos[finish].back().second<<endl;
    }
}
