/* GCC */
#include <iostream>
#include <vector>
using namespace std;

int n, m, t0, a, b;

struct conn{
       int to;
       int ta, tb;
       int c;
};

vector<conn> stops[251];
bool wasin[250] = {false,};

int tmin, ctmin;
int cmin, tcmin;

bool fastest(int t, int c){if ((t < tmin) || (t == tmin && c < ctmin)){ tmin = t; ctmin = c;}}
bool lowest(int t, int c){ if ((c < cmin) || (c == cmin && t < tcmin)){ cmin = c; tcmin = t;}}

void findFastest(int a, int b, int t0, int cst = 0, int type = 1){
    wasin[a] = true;
    if (a == b){ if (type == 1) fastest(t0, cst); else lowest(t0, cst); wasin[a] = false; return;}
    for(int i = 0; i < stops[a].size(); i++){
      if (!wasin[stops[a][i].to])
      if (stops[a][i].ta >= t0){
         findFastest(stops[a][i].to, b, stops[a][i].tb, cst+stops[a][i].c, type);
      }
      else findFastest(stops[a][i].to, b, 1440+stops[a][i].tb, cst+stops[a][i].c, type);
    }
    wasin[a] = false;
}

int main(){
    freopen("tax.in", "r", stdin);
    freopen("tax.out", "w", stdout);
    cin>>n>>m>>t0>>a>>b;
    tmin = 654321; ctmin = 654321;
    cmin = 654321; tcmin = 654321;
    int tmp; conn con;
    int s, t, c, ts, tt;
    while(!cin.eof()){
      cin>>s>>t>>c;
      if (c != 0){
        con.to = s;
        con.ta = tt+1;
        con.tb = t;
        con.c = c;
        stops[ts].push_back(con);
      }
      ts = s; tt = t;
    };
    findFastest(a, b, t0, 0, 1);
    findFastest(a, b, t0, 0, 2);
    cout<<tmin<<" "<<ctmin<<endl;
    cout<<tcmin<<" "<<cmin<<endl;
}
