/* GCC */
#include <iostream>
#include <algorithm>
#include <sstream>

#define INF 1000000

using namespace std;

struct edge
{
       unsigned int f, s, f_time, s_time, m;
};

struct vert
{
       unsigned int t, m;
};

char ss[500000];
unsigned int n, m, t, a, b, edg_sz = 0, f, f_t, money, s, s_t;
edge edg[7900];
vert v_for_t[260], v_for_m[260];

void push_edge( int f, int s, int f_time, int s_time, int mon )
{
     edg[edg_sz].f = f;
     edg[edg_sz].s = s;
     edg[edg_sz].f_time = f_time;
     edg[edg_sz].s_time = s_time;
     edg[edg_sz].m = mon;
     edg_sz++;
     return;
}

bool comp( edge a, edge b )
{
     return a.f_time < b.f_time;
}

int main()
{
    freopen("tax.in", "r", stdin);
    freopen("tax.out", "w", stdout);
    
    scanf("%d%d%d%d%d", &n, &m, &t, &a, &b);
    a--;
    b--;
    for( int i = 0; i < n; i++ ) v_for_t[i].t = INF, v_for_t[i].m = INF, v_for_m[i].t = INF, v_for_m[i].m = INF;
    v_for_t[a].t = t;
    v_for_t[a].m = 0;
    v_for_m[a].t = t;
    v_for_m[a].m = 0;
    
    for( int i = 0; i < m; i++ )
    {
         gets(ss);
         istringstream iss(ss);
         iss >> f >> f_t >> money;
         f--;
         while( iss >> s >> s_t >> money )
         {
                s--;
                push_edge( f, s, f_t, s_t, money );
                f = s;
                f_t = s_t;
         }
    }
    
    sort( &edg[0], &edg[edg_sz], comp );
    int time = 0;
    bool change = 1;
    while( change == 1 )
    {
           change = 0;
           for( int i = 0; i < edg_sz; i++ )
           {
                if( v_for_t[edg[i].f].t == INF ) continue;
                if( v_for_t[edg[i].f].t <= edg[i].f_time + time )
                {
                    if( ( edg[i].s_time + time < v_for_t[edg[i].s].t ) || ( ( edg[i].s_time + time == v_for_t[edg[i].s].t ) && ( v_for_t[edg[i].f].m + edg[i].m < v_for_t[edg[i].s].m ) ) )
                    {
                        change = 1;
                        v_for_t[edg[i].s].t = edg[i].s_time + time;
                        v_for_t[edg[i].s].m = v_for_t[edg[i].f].m + edg[i].m;
                    }
                }
           }
           time += 1440;
    }
    time = 0;
    change = 1;
    while( change == 1 )
    {
           change = 0;
           for( int i = 0; i < edg_sz; i++ )
           {
                if( v_for_m[edg[i].f].t == INF ) continue;
                if( v_for_m[edg[i].f].t <=  (edg[i].f_time + time) )
                {
                    if( ( v_for_m[edg[i].s].m > ( v_for_m[edg[i].f].m + edg[i].m ) ) || ( ( v_for_m[edg[i].s].m == (v_for_m[edg[i].f].m + edg[i].m) ) && ( (edg[i].s_time + time) < v_for_m[edg[i].s].t ) ) )
                    {
                        change = 1;
                        v_for_m[edg[i].s].t = edg[i].s_time + time;
                        v_for_m[edg[i].s].m = v_for_m[edg[i].f].m + edg[i].m;
                    }
                }
           }
           time += 1440;
    }
    
    printf("%d %d\n", v_for_t[b].t, v_for_t[b].m);
    printf("%d %d\n", v_for_m[b].t, v_for_m[b].m);
    
    fclose(stdin);
    fclose(stdout);
    return 0;
}
